%define debug_package %{nil}
%define oname	hybrid-v35
%define dwver	6_30_223_271
%define kname	wl

Summary:	Proprietary driver for Broadcom wireless adapters
Name:		broadcom-wl
Version:	6.30.223.271
Release:	%mkrel 48
Source0:	http://www.broadcom.com/docs/linux_sta/%{oname}-nodebug-pcoem-%{dwver}.tar.gz
Source1:	http://www.broadcom.com/docs/linux_sta/%{oname}_64-nodebug-pcoem-%{dwver}.tar.gz
Source2:	broadcom-wl-blacklist.conf
Source3:	broadcom-wl-alias.conf
# fix crash (ubuntu, mga#16390)
Patch6:		broadcom-wl-6.30.223.271-fix-null-pointer-crash.patch
# fix build with 4.3 (aur)
Patch7:		broadcom-wl-6.30.223.271-kernel-4.3-rdtscl-buildfix.patch
# (tmb) fix build with 4.7
Patch8:		broadcom-wl-6.30.223.271-kernel-4.7-buildfix.patch
# (tmb) fix build with 4.8 (aur)
Patch9:		broadcom-wl-6.30.223.271-kernel-4.8-buildfix.patch
# (tmb) fix build with 4.11 (aur)
Patch10:	linux411.patch
# (tmb) fix build with 4.12 (aur)
Patch11:	linux412.patch
# Blob is under a custom license (see LICENSE.txt), everything else
# is GPLv2 - AdamW 2008/12
License:	Freeware and GPLv2 with exception
Group:		System/Kernel and hardware
URL:		http://www.broadcom.com/support/802.11/linux_sta.php

%description
This package contains the proprietary driver for Broadcom wireless
adapters provided by Broadcom. If installed, it will be used for
these cards in preference to the third-party open source driver that
requires manual installation of firmware, or ndiswrapper.

%package -n dkms-%{name}
Summary:	Kernel module for Broadcom wireless adapters
Group:		System/Kernel and hardware
Provides:	kmod(%{kname}.ko) = %{version}
Requires:		dkms >= 2.0.19-37
Requires(post):		dkms >= 2.0.19-37
Requires(preun):	dkms >= 2.0.19-37
Requires:	%{name}-common
# (tmb) prebuilt kmods violates gpl
%ifarch %{ix86}
%rename		broadcom-wl-kernel-desktop586-latest
%endif
%rename		broadcom-wl-kernel-desktop-latest
%rename		broadcom-wl-kernel-server-latest

%description -n dkms-%{name}
This package contains the proprietary driver for Broadcom wireless
adapters provided by Broadcom. If installed, it will be used for
these cards in preference to the third-party open source driver that
requires manual installation of firmware, or ndiswrapper.

%package -n %{name}-common
Summary:	Common files for Broadcom-wl drivers
Group:		System/Kernel and hardware
Conflicts:	dkms-%{name} <= 5.100.82.112-7
Conflicts:	broadcom-bcma-config
Conflicts:	broadcom-ssb-config

%description -n %{name}-common
This package contains the blacklist and ldetect-lst files shared
between dkms-broadcom-wl and the prebuilt broadcom-wl-* drivers.

%prep
%ifarch x86_64
%setup -q -T -c -a1 %{oname}
%else
%setup -q -T -c -a0 %{oname}
%endif

%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1

%build

%install
rm -rf %{buildroot}

# add blacklist for conflicting in-kernel modules
install -m755 -d %{buildroot}%{_sysconfdir}/modprobe.d/
install -m644 %{SOURCE2} %{buildroot}%{_sysconfdir}/modprobe.d
# add pciids for ldetect-lst and libkmod
install -m644 %{SOURCE3} %{buildroot}%{_sysconfdir}/modprobe.d

# install dkms sources
mkdir -p %{buildroot}%{_usr}/src/%{name}-%{version}-%{release}
cp -R * %{buildroot}%{_usr}/src/%{name}-%{version}-%{release}/
cat > %{buildroot}%{_usr}/src/%{name}-%{version}-%{release}/dkms.conf << EOF
MAKE="'make' -j\${parallel_jobs} -C \$kernel_source_dir M=\\\$(pwd)"
PACKAGE_NAME=%{name}
PACKAGE_VERSION=%{version}-%{release}
DEST_MODULE_LOCATION=/kernel/3rdparty/%{name}
BUILT_MODULE_NAME=%{kname}
AUTOINSTALL=yes
EOF

%post -n dkms-%{name}
set -x
/usr/sbin/dkms --rpm_safe_upgrade add -m %{name} -v %{version}-%{release}
if [ -z "$DURING_INSTALL" ] ; then
    /usr/sbin/dkms --rpm_safe_upgrade build -m %{name} -v %{version}-%{release} &&
    /usr/sbin/dkms --rpm_safe_upgrade install -m %{name} -v %{version}-%{release}
fi

%preun -n dkms-%{name}
# rmmod can fail
/sbin/rmmod %{kname} >/dev/null 2>&1 ||:
set -x
/usr/sbin/dkms --rpm_safe_upgrade remove -m %{name} -v %{version}-%{release} --all || :

%posttrans -n %{name}-common
if [ -z "$DURING_INSTALL" ] ; then
    /sbin/rmmod b43 >/dev/null 2>&1 ||:
    /sbin/rmmod b43legacy >/dev/null 2>&1 ||:
    /sbin/rmmod brcmfmac >/dev/null 2>&1 ||:
    /sbin/rmmod brcmsmac >/dev/null 2>&1 ||:
    /sbin/rmmod bcma >/dev/null 2>&1 ||:
    /sbin/rmmod ssb >/dev/null 2>&1 ||:
    /sbin/modprobe wl >/dev/null 2>&1 ||:
fi

%clean
rm -rf %{buildroot}

%files -n dkms-%{name}
%doc lib/LICENSE.txt
%dir %{_usr}/src/%{name}-%{version}-%{release}
%{_usr}/src/%{name}-%{version}-%{release}/*

%files -n %{name}-common
%config %{_sysconfdir}/modprobe.d/%{name}-alias.conf
%config %{_sysconfdir}/modprobe.d/%{name}-blacklist.conf


%changelog
* Sat Dec 09 2017 tmb <tmb> 6.30.223.271-48.mga6
+ Revision: 1181834
- fix build with kernels up to 4.14

* Wed Apr 26 2017 tmb <tmb> 6.30.223.271-46.mga6.nonfree
+ Revision: 1097661
- dont trigger dkms build during classical install (mga#20155)

* Sat Dec 10 2016 tmb <tmb> 6.30.223.271-45.mga6.nonfree
+ Revision: 1073931
- support kernel 4.8 series (mga#19866, aur)

* Mon Jul 04 2016 tmb <tmb> 6.30.223.271-44.mga6.nonfree
+ Revision: 1038669
- fix build with kernel 4.7 series

* Wed Jun 15 2016 tmb <tmb> 6.30.223.271-43.mga6.nonfree
+ Revision: 1021613
- hook into dkms parallel build support

* Mon May 30 2016 tmb <tmb> 6.30.223.271-42.mga6.nonfree
+ Revision: 1019491
- fix duplicated/broken provides on dkms package
- rebuild with gcc 5.4
- obsolete prebuilt kmods as they violate GPL

* Sat Dec 05 2015 tmb <tmb> 6.30.223.271-4.mga6.nonfree
+ Revision: 908284
- rebuild with gcc 5.3 final

* Sun Nov 22 2015 tmb <tmb> 6.30.223.271-3.mga6.nonfree
+ Revision: 904846
- fix 32bit build with 4.3 series kernels

* Sun Nov 22 2015 tmb <tmb> 6.30.223.271-2.mga6.nonfree
+ Revision: 904838
- rebuild for missing package

* Mon Oct 05 2015 tmb <tmb> 6.30.223.271-1.mga6.nonfree
+ Revision: 886447
- update to 6.30.223.271 (mga#16908)
  * drop patches P1-P5, P7

* Wed Sep 30 2015 tmb <tmb> 6.30.223.248-8.mga6.nonfree
+ Revision: 885376
- fix build with kernel 4.2

* Wed Sep 09 2015 neoclust <neoclust> 6.30.223.248-7.mga6.nonfree
+ Revision: 874957
- Fix build with new rpm ( empty debuginfo)

* Fri Aug 21 2015 tmb <tmb> 6.30.223.248-6.mga6.nonfree
+ Revision: 867071
- rebuild for new gcc

* Thu Aug 20 2015 tmb <tmb> 6.30.223.248-5.mga6
+ Revision: 866759
- rebuild with gcc 5.2.1

* Tue Jul 21 2015 tmb <tmb> 6.30.223.248-4.mga6.nonfree
+ Revision: 856015
- fix null pointer crash (mga#16390)

* Tue Jul 07 2015 tmb <tmb> 6.30.223.248-3.mga6.nonfree
+ Revision: 852312
- fix build with 4.0+ series kernels

* Mon Dec 08 2014 tmb <tmb> 6.30.223.248-2.mga5.nonfree
+ Revision: 802163
- fix up P4

* Sat Dec 06 2014 doktor5000 <doktor5000> 6.30.223.248-1.mga5.nonfree
+ Revision: 801751
- new version 6.30.223.248
- dropped broadcom-wl-6.30.223.141-kernel-3.10.patch
- rediffed broadcom-wl-gcc-4.9.patch
- rediffed broadcom-wl-6.30.223.141-kernel-3.18.patch to broadcom-wl-6.30.223.248-kernel-3.18.patch

* Sat Nov 29 2014 tmb <tmb> 6.30.223.141-11.mga5.nonfree
+ Revision: 799913
- fix build with 3.18 series kernels

* Wed Oct 15 2014 umeabot <umeabot> 6.30.223.141-10.mga5.nonfree
+ Revision: 739991
- Second Mageia 5 Mass Rebuild

* Wed Sep 24 2014 tmb <tmb> 6.30.223.141-9.mga5.nonfree
+ Revision: 723708
- fix typo in kmod provides

* Wed Sep 24 2014 tmb <tmb> 6.30.223.141-8.mga5.nonfree
+ Revision: 723644
- adapt to new kmod provides

* Tue Sep 16 2014 umeabot <umeabot> 6.30.223.141-7.mga5.nonfree
+ Revision: 678228
- Mageia 5 Mass Rebuild

* Wed Sep 03 2014 tmb <tmb> 6.30.223.141-6.mga5.nonfree
+ Revision: 671155
- fix build with 3.17 series kernels

* Mon Jun 09 2014 tmb <tmb> 6.30.223.141-5.mga5.nonfree
+ Revision: 634874
- fix build with kernel-3.15

* Wed May 14 2014 tmb <tmb> 6.30.223.141-4.mga5.nonfree
+ Revision: 622723
- fix kmod build with gcc 4.9

* Tue May 13 2014 tmb <tmb> 6.30.223.141-3.mga5.nonfree
+ Revision: 622567
- rebuild with gcc 4.9

* Thu Oct 31 2013 tmb <tmb> 6.30.223.141-2.mga4.nonfree
+ Revision: 548329
- Mageia 4 rebuild

* Sat Oct 05 2013 tmb <tmb> 6.30.223.141-1.mga4.nonfree
+ Revision: 492028
- update and sort aliases list
- fix build with kernel-3.10+ (openmamba)
- drop obsolete patches
- update to 6.30.223.141

* Sun Aug 11 2013 tmb <tmb> 5.100.82.112-14.mga4.nonfree
+ Revision: 465469
- rebuild with new gcc

* Mon Jul 15 2013 tmb <tmb> 5.100.82.112-13.mga4.nonfree
+ Revision: 454864
- fix build with kernel 3.10 (P2, aur)

* Sat May 04 2013 tmb <tmb> 5.100.82.112-12.mga3.nonfree
+ Revision: 412316
- silence rmmod warnings when modules are not loaded

* Sat May 04 2013 tmb <tmb> 5.100.82.112-11.mga3.nonfree
+ Revision: 412262
- conflict broadcom-bcma-config and broadcom-ssb-config
- remove reference to nonexisting brcm80211
- unload conflicting drivers and load wl driver when installed

* Fri Feb 08 2013 tmb <tmb> 5.100.82.112-10.mga3.nonfree
+ Revision: 396959
- blacklist b43legacy, brcmsmac and brcmfmac too

* Wed Jan 23 2013 tmb <tmb> 5.100.82.112-9.mga3.nonfree
+ Revision: 391728
- fix alias list so it is actually used when installed

* Wed Jan 23 2013 tmb <tmb> 5.100.82.112-8.mga3.nonfree
+ Revision: 391697
- add pciids for ldetect-lst to detect wl drivers when installed
- split out module blacklist to a separate -common package

* Fri Jan 11 2013 umeabot <umeabot> 5.100.82.112-7.mga3.nonfree
+ Revision: 347202
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Thu Jan 10 2013 tmb <tmb> 5.100.82.112-6.mga3.nonfree
+ Revision: 344817
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Mon May 28 2012 tmb <tmb> 5.100.82.112-5.mga3.nonfree
+ Revision: 247960
- fix build with 3.4 series kernels (P1)

* Mon Dec 26 2011 tmb <tmb> 5.100.82.112-4.mga2.nonfree
+ Revision: 187931
- fix build with 3.2 series kernels
- drop unused .conf file
- drop buildroot and defattr

* Mon Dec 05 2011 zezinho <zezinho> 5.100.82.112-3.mga2.nonfree
+ Revision: 177045
- blacklist more modules to fix #3618

* Tue Nov 08 2011 zezinho <zezinho> 5.100.82.112-2.mga2.nonfree
+ Revision: 165305
- bump release because it is also in 1/updates

* Tue Nov 08 2011 zezinho <zezinho> 5.100.82.112-1.mga2.nonfree
+ Revision: 165290
- new version

* Sun Apr 10 2011 tmb <tmb> 5.100.82.38-3.mga1
+ Revision: 83052
- blacklist brcm80211 if wl module is installed (#327)

* Sun Mar 20 2011 tmb <tmb> 5.100.82.38-2.mga1
+ Revision: 75009
- fix build with 2.6.37+ series kernels (#438)

* Thu Mar 17 2011 tmb <tmb> 5.100.82.38-1.mga1
+ Revision: 73292
- imported package broadcom-wl

